using CP;

int pocetStroju = ...;
int pocetRobotu = ...;
int pocetVyrobku= ...;
int pocetZamestnancu = ...;

range Stroje = 1..pocetStroju;
range Roboti = 1..pocetRobotu;
range Vyrobky = 1..pocetVyrobku;

tuple Operace {
  int trvani;
  {int} roboti;
  int lidi;
}

Operace operace[Vyrobky][Stroje] = ...;

dvar interval casy[v in Vyrobky][s in Stroje] size operace[v][s].trvani;
dvar sequence stroj[s in Stroje] in all (v in Vyrobky) casy[v][s];

dvar interval prirazeni[v in Vyrobky][s in Stroje][r in Roboti] optional;
dvar sequence robot[r in Roboti] in all (v in Vyrobky, s in Stroje: r in operace[v][s].roboti) prirazeni[v][s][r];

cumulFunction zamestnanci = sum (v in Vyrobky, s in Stroje) pulse(casy[v][s], operace[v][s].lidi);

minimize max (v in Vyrobky) endOf(casy[v][pocetStroju]);

subject to {

  forall (s in Stroje) 
    noOverlap(stroj[s]);

  forall (r in Roboti) 
    noOverlap(robot[r]);
    
  zamestnanci <= pocetZamestnancu;  
    
  forall (v in Vyrobky, s in 1..pocetStroju-1)
    endBeforeStart(casy[v][s], casy[v][s+1]); 
    
  forall (v in Vyrobky, s in Stroje)
    alternative(casy[v][s], all (r in operace[v][s].roboti) prirazeni[v][s][r]);
   
  forall  (v in Vyrobky, s in Stroje, r in Roboti: r not in operace[v][s].roboti)
    presenceOf(prirazeni[v][s][r]) == 0;
  
}
  
 