/******************************
* Assign shops to branches    *
*******************************/

using CP;
 
/*******
* Data *
*******/

{string} Shops = ...;
int NbBranches = ...;
range Branches = 0..NbBranches-1;

int Capacity[Shops] = ...;                // maximum number branches assigned to each shop
int SupplyCost[Branches][Shops] = ...;    // supply cost between each branchee and each shop

/*********************
* Decision variables *
*********************/

dvar boolean Supply[Branches][Shops];    // 1 if store supplied by shop, 0 otherwise   

dvar int+ TotalCost;                     // additional domain variable for the optimization cost

/*********************
* Objective function *
*********************/

minimize TotalCost;
    
/**************
* Constraints *
**************/

subject to {
   
  forall( s in Branches )
    sum( w in  Shops ) Supply[s][w] == 1;
    
  forall( w in Shops )
    sum( s in Branches ) Supply[s][w] <= Capacity[w];
    
  TotalCost == sum( w in Shops , s in Branches ) SupplyCost[s][w] * Supply[s][w];
}