// Vzorove reseni problemu planovani projektu

using CP;

tuple Ukol {
  int trvani;
  int osoba;
}

tuple Prec {
  int Po;
  int Pred;
}

tuple Same {
   int Prvni;
   int Druha;
}

int pocetUkolu = ...;

int pocetOsob = ...;

Ukol ukoly[1..pocetUkolu] = ...;

int limit[1..pocetOsob] = ...;

{Prec} prec = ...;

{Same} same = ...;

// domenove promenne pro startovni casy
dvar interval casy [u in 1..pocetUkolu] size ukoly[u].trvani;

// kumulativni funkce pocitajici vytizeni osob v case
cumulFunction osoby[o in 1..pocetOsob] = 
   sum (u in 1..pocetUkolu: ukoly[u].osoba == o) pulse(casy[u],1);

// minimalizace souctu koncovych casu
minimize sum (u in 1..pocetUkolu) endOf(casy[u]);

subject to {

   // omezime maximalni zatizeni kazde osoby v kazdem case
   forall (o in 1..pocetOsob) osoby[o] <= limit[o]; 
 
   // precedencni podminky
   forall (p in prec) endBeforeStart(casy[p.Pred],casy[p.Po]);

   // stejne startovni casy
   forall (s in same) startAtStart(casy[s.Prvni],casy[s.Druha]);
}
