% ----------------------------------------------------------------------------
% vstupni data
% ----------------------------------------------------------------------------

% job( JobId, Duration, Person )
job(1,3,1).
job(2,2,1).
job(3,1,1).  
job(4,4,1).  
job(5,2,1).  
job(6,4,2).  
job(7,2,2).  
job(8,1,2).  
job(9,1,2).  
job(10,3,2).  
job(11,2,3).  
job(12,2,3).  
job(13,1,3).  
job(14,1,3).

% limit( PersonId, Limit )
% osoba Person smi pracovat nejvyse na Limit ukolech zaroven
limit(1,2).
limit(2,2).
limit(3,1).

% same( K, L ) 
% ukol K zacina stejne jako ukol L
same(1,2).
same(7,8).

% prec( I, J )
% ukol I zacina az po ukolu J
prec(3,1).
prec(6,7).

% ----------------------------------------------------------------------------
% vysvetleni zakladniho pouziti predikatu findall/3
% ----------------------------------------------------------------------------

% zakladni pouziti:
% findall( TvarVracenohoPrvkuSeznamu, HledanyFakt, Seznam )
%
% ?- findall( PersonId-Limit, limit(PersonId,Limit), List).
% v seznamu List vrati vsechny dvojice PersonId-Limit, pro ktere 
% plati limit(PersonId,Limit)
% ?- findall( PersonId-Limit, limit(PersonId,Limit), List).
% List = [1-2,2-2,3-1] ? 
%
% ?- findall( PersonId, limit(PersonId,2), List).
% v seznamu List vrati vsechny osoby PersonId, pro ktere 
% plati limit(PersonId,2), tj. jejich Limit je 2
% List = [1,2] ? 
% ?- findall( PersonId, limit(PersonId,4), List).
% List = [] ?

% ----------------------------------------------------------------------------
% predikaty pro nalezeni seznamu ukolu
% ----------------------------------------------------------------------------

% vrati seznam vsech ukolu
% ?- find_all_jobs(AllJobs).
find_all_jobs( AllJobs ) :-
	findall( job( JobId, Duration, PersonId ), 
	         job( JobId, Duration, PersonId ),
	         AllJobs ).

% vrati seznam vsech ukolu osoby se zadanym PersonId
% napr. ?- find_person_jobs(PersonJobs,1). 
find_person_jobs( PersonJobs, PersonId ) :-
	findall( job( JobId, Duration, PersonId ), 
	         job( JobId, Duration, PersonId ),
	         PersonJobs ).
