/*********************************************
 * OPL 12.7.1.0 Model
 * Author: hanka
 * Creation Date: 18. 10. 2017 at 10:34:59
 *********************************************/

 using CP;
 
 int number = ...;
 
 range Lectures = 1..number;
 
 int duration[Lectures] = ...;
 int earliest[Lectures] = ...;
 int latest[Lectures] = ...;
 
 tuple Prec {
     int Before;
     int After; 
 }
 
{Prec} precedences = ...;

dvar interval start[l in Lectures] in earliest[l]..latest[l] size duration[l];
dvar sequence seq in start;

minimize max(l in Lectures) endOf(start[l]);

subject to {
     noOverlap(seq);
     forall (p in precedences) endBeforeStart(start[p.Before],start[p.After]);
}
