/*********************************************
 * OPL 12.7.1.0 Model
 * Author: hanka
 * Creation Date: 21. 11. 2017 at 19:14:11
 *********************************************/

 using CP;
 
 int pocetZamestnancu = ...;
 int pocetDnu = ...;
 int pocetUkolu = ...;
 int trvani = ...;

 range Zamestnanci = 1..pocetZamestnancu;
 range Dny = 1..pocetDnu;
 range Ukoly = 1..pocetUkolu;
 
 tuple Ukol {
  key int id;
  int pocet;
  int hodin;
  int preference;
 }
  
 tuple Zamestnanec {
  key int id;
  int od;
 }
 
 Ukol ukoly[Ukoly] = ...; 
 Zamestnanec zamestnanci[Zamestnanci] = ...;

 dvar interval casy[z in Zamestnanci][d in Dny] 
               in zamestnanci[z].od .. (zamestnanci[z].od+trvani) size trvani;
 
 dvar interval prirazeni[z in Zamestnanci][d in Dny][u in Ukoly] optional;
 
 cumulFunction pocetUkol[u in Ukoly][d in Dny] = 
               sum (z in Zamestnanci) pulse(prirazeni[z][d][u],1);
               
 cumulFunction hodinUkol[u in Ukoly][z in Zamestnanci] = 
               sum (d in Dny) pulse(prirazeni[z][d][u],trvani);              
 
 minimize sum (z in Zamestnanci, d in Dny, u in Ukoly) 
              presenceOf(prirazeni[z][d][u])*ukoly[u].preference; 
 
 subject to {
   
   forall (z in Zamestnanci, d in Dny) 
      alternative(casy[z][d], all (u in Ukoly) prirazeni[z][d][u]);
     
   forall (u in Ukoly, d in Dny) 
      pocetUkol[u][d] <= ukoly[u].pocet;    
    
   forall (z in Zamestnanci, u in Ukoly) 
      hodinUkol[u][z] <= ukoly[u].hodin; 
   
}  
 
 
